;################################################################################
;#										#
;# libmio - multi i/o for ATMega644						#
;# keytable - DE layout								#
;# copyright (c) 2007-2010 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;# This library is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU Lesser General Public			#
;# License as published by the Free Software Foundation; either			#
;# version 3 of the License, or (at your option) any later version.		#
;#										#
;# This library is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the GNU		#
;# Lesser General Public License for more details.				#
;#										#
;# You should have received a copy of the GNU Lesser General Public		#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################

.db	0x00,0x00	;keycode 0x00/0x01	 no valid key
.db	0x00,0x00	;keycode 0x02/0x03	 no valid key
.db	0x00,0x00	;keycode 0x04/0x05	 no valid key
.db	0x00,0x00	;keycode 0x06/0x07	 no valid key
.db	0x00,0x00	;keycode 0x08/0x09	 no valid key
.db	0x00,0x00	;keycode 0x0a/0x0b	 no valid key
.db	0x00,0x00	;keycode 0x0c/0x0d	 no valid key
.db	0x00,0x00	;keycode 0x0e/0x0f	 no valid key

.db	0x00,0x00	;keycode 0x10/0x11	 no valid key
.db	0x00,0x00	;keycode 0x12/0x13	 no valid key
.db	0x00,0x00	;keycode 0x14/0x15	 no valid key
.db	0x00,0x00	;keycode 0x16/0x17	 no valid key
.db	0x00,0x00	;keycode 0x18/0x19	 no valid key
.db	0x00,0x00	;keycode 0x1a/0x1b	 no valid key
.db	0x00,0x00	;keycode 0x1c/0x1d	 no valid key
.db	0x00,0x00	;keycode 0x1e/0x1f	 no valid key

.db	0xa0,0xb3	;keycode 0x20/0x21	space / edit
.db	0xb4,0x00	;keycode 0x22/0x23	AND / nvc
.db	0xb6,0xb7	;keycode 0x24/0x25	TO / cursor left
.db	0xbc,0x00	;keycode 0x26/0x27	cursor down / nvc
.db	0xba,0xb9	;keycode 0x28/0x29	cursor right, graphics
.db	0xcb,0xc4	;keycode 0x2a/0x2b	* / +
.db	0xc8,0xc5	;keycode 0x2c/0x2d	, / -
.db	0xa1,0xbb	;keycode 0x2e/0x2f	. / cursor up

.db	0x91,0x8c	;keycode 0x30/0x31	0 / 1
.db	0x8d,0x8e	;keycode 0x32/0x33	2 / 3
.db	0x8f,0x90	;keycode 0x34/0x35	4 / 5
.db	0x95,0x94	;keycode 0x36/0x37	6 / 7
.db	0x93,0x92	;keycode 0x38/0x39	8 / 9
.db	0xa5,0xa6	;keycode 0x3a/0x3b	: / ;
.db	0xca,0xc3	;keycode 0x3c/0x3d	< / =
.db	0xc9,0xa7	;keycode 0x3e/0x3f	> / ?

.db	0xb5,0xa9	;keycode 0x40/0x41	THEN / STOP
.db	0xcb,0xa7	;keycode 0x42/0x43	* / ?
.db	0xab,0xb0	;keycode 0x44/0x45	SLOW / STEP
.db	0xac,0xad	;keycode 0x46/0x47	FAST / LLIST
.db	0xc6,0xbf	;keycode 0x48/0x49	** / (
.db	0xc5,0xc4	;keycode 0x4a/0x4b	- / +
.db	0xc3,0xc9	;keycode 0x4c/0x4d	= / >
.db	0xca,0xbe	;keycode 0x4e/0x4f	< / )

.db	0xbd,0xae	;keycode 0x50/0x51	" / ""
.db	0xb1,0xaa	;keycode 0x52/0x53	<= / LPRINT
.db	0xb2,0xc0	;keycode 0x54/0x55	<> / $
.db	0xa8,0xaf	;keycode 0x56/0x57	/ / OR
.db	0xa6,0xa5	;keycode 0x58/0x59	; / >=
.db	0xc1,0x00	;keycode 0x5a/0x5b	: / nvc
.db	0x00,0x00	;keycode 0x5c/0x5d	nvc / nvc
.db	0x00,0x00	;keycode 0x5e/0x5f	nvc / nvc

.db	0x00,0x82	;keycode 0x60/0x61	nvc / A
.db	0xa4,0x80	;keycode 0x62/0x63	B / C
.db	0x84,0x89	;keycode 0x64/0x65	D / E
.db	0x85,0x86	;keycode 0x66/0x67	F / H
.db	0x9f,0x98	;keycode 0x68/0x69	H / I
.db	0x9e,0x9d	;keycode 0x6a/0x6b	J / K
.db	0x9c,0xa2	;keycode 0x6c/0x6d	L / M
.db	0xa3,0x97	;keycode 0x6e/0x6f	N / O

.db	0x96,0x87	;keycode 0x70/0x71	P / Q
.db	0x8a,0x83	;keycode 0x72/0x73	R / S
.db	0x8b,0x99	;keycode 0x74/0x75	T / U
.db	0x81,0x88	;keycode 0x76/0x77	V / W
.db	0x7f,0x7e	;keycode 0x78/0x79	X / Y
.db	0x9a,0x00	;keycode 0x7a/0x7b	Z / nvc
.db	0x00,0x00	;keycode 0x7c/0x7d	nvc / nvc
.db	0x00,0x00	;keycode 0x7e/0x7f	nvc / nvc

.db	0x00,0x00	;keycode 0x80/0x81	 no valid key
.db	0x00,0x00	;keycode 0x82/0x83	 no valid key
.db	0x00,0x00	;keycode 0x84/0x85	 no valid key
.db	0x00,0x00	;keycode 0x86/0x87	 no valid key
.db	0x00,0x00	;keycode 0x88/0x89	 no valid key
.db	0x00,0x00	;keycode 0x8a/0x8b	 no valid key
.db	0x00,0x00	;keycode 0x8c/0x8d	 no valid key
.db	0x00,0x00	;keycode 0x8e/0x8f	 no valid key

.db	0x00,0x00	;keycode 0x90/0x91	 no valid key
.db	0x00,0x00	;keycode 0x92/0x93	 no valid key
.db	0x00,0x00	;keycode 0x94/0x95	 no valid key
.db	0x00,0x00	;keycode 0x96/0x97	 no valid key
.db	0x00,0x00	;keycode 0x98/0x99	 no valid key
.db	0x00,0x00	;keycode 0x9a/0x9b	 no valid key
.db	0x00,0x00	;keycode 0x9c/0x9d	 no valid key
.db	0x00,0x00	;keycode 0x9e/0x9f	 no valid key

.db	0xc9,0x00	;keycode 0xa0/0xa1	 s+space / nvc
.db	0x00,0x00	;keycode 0xa2/0xa3	 no valid key
.db	0x00,0x00	;keycode 0xa4/0xa5	 no valid key
.db	0x00,0x00	;keycode 0xa6/0xa7	 no valid key
.db	0x00,0x00	;keycode 0xa8/0xa9	 no valid key
.db	0x00,0x00	;keycode 0xaa/0xab	 no valid key
.db	0x00,0x00	;keycode 0xac/0xad	 no valid key
.db	0x00,0x00	;keycode 0xae/0xaf	 no valid key

.db	0x00,0x00	;keycode 0xb0/0xb1	 no valid key
.db	0x00,0x00	;keycode 0xb2/0xb3	 no valid key
.db	0x00,0x00	;keycode 0xb4/0xb5	 no valid key
.db	0x00,0x00	;keycode 0xb6/0xb7	 no valid key
.db	0x00,0x00	;keycode 0xb8/0xb9	 no valid key
.db	0x00,0x00	;keycode 0xba/0xbb	 no valid key
.db	0x00,0x00	;keycode 0xbc/0xbd	 no valid key
.db	0x00,0x00	;keycode 0xbe/0xbf	 no valid key

.db	0x00,0x00	;keycode 0xc0/0xc1	 no valid key
.db	0x00,0x00	;keycode 0xc2/0xc3	 no valid key
.db	0x00,0x00	;keycode 0xc4/0xc5	 no valid key
.db	0x00,0x00	;keycode 0xc6/0xc7	 no valid key
.db	0x00,0x00	;keycode 0xc8/0xc9	 no valid key
.db	0x00,0x00	;keycode 0xca/0xcb	 no valid key
.db	0x00,0x00	;keycode 0xcc/0xcd	 no valid key
.db	0x00,0x00	;keycode 0xce/0xcf	 no valid key

.db	0x00,0x00	;keycode 0xd0/0xd1	 no valid key
.db	0x00,0x00	;keycode 0xd2/0xd3	 no valid key
.db	0x00,0x00	;keycode 0xd4/0xd5	 no valid key
.db	0x00,0x00	;keycode 0xd6/0xd7	 no valid key
.db	0x00,0x00	;keycode 0xd8/0xd9	 no valid key
.db	0x00,0x00	;keycode 0xda/0xdb	 no valid key
.db	0x00,0x00	;keycode 0xdc/0xdd	 no valid key
.db	0x00,0x00	;keycode 0xde/0xdf	 no valid key

.db	0x00,0x00	;keycode 0xe0/0xe1	 no valid key
.db	0xb7,0xba	;keycode 0xe2/0xe3	 cursor left / cursor right
.db	0xbb,0xbc	;keycode 0xe4/0xe5	 cursor up / cursor down
.db	0x00,0x00	;keycode 0xe6/0xe7	 no valid key
.db	0x00,0x00	;keycode 0xe8/0xe9	 no valid key
.db	0x9b,0xc2	;keycode 0xea/0xeb	 ENTER / FUNCTION
.db	0xb8,0x00	;keycode 0xec/0xed	 BS / nvc
.db	0x00,0x00	;keycode 0xee/0xcef	 no valid key

.db	0x00,0x00	;keycode 0xf0/0xf1	 no valid key
.db	0x00,0x00	;keycode 0xf2/0xf3	 no valid key
.db	0x00,0x00	;keycode 0xf4/0xf5	 no valid key
.db	0x00,0x00	;keycode 0xf6/0xf7	 no valid key
.db	0x00,0x00	;keycode 0xf8/0xf9	 no valid key
.db	0x00,0x00	;keycode 0xfa/0xfb	 no valid key
.db	0x00,0x00	;keycode 0xfc/0xfd	 no valid key
.db	0x00,0x00	;keycode 0xfe/0xff	 no valid key

